SetType (API documentation of hlt.language packages)
Date: 2013-01-30

hlt.language.design.types

## Class SetType

- java.lang.Object
- - hlt.language.design.types.Type
  - - hlt.language.design.types.StaticType
    - - hlt.language.design.types.ConstructedType
      - - hlt.language.design.types.CollectionType
        - - hlt.language.design.types.SetType

- All Implemented Interfaces:
    Collection, Valuable

      public class SetType
      extends CollectionType

  This is the class denoting the type of sets. Types of this kind consist of set types whose elements are of any base type (including sets - thus enabling higher-order sets - and type parameters - thus enabling polymorphic sets).

- - ### Field Summary

    - ### Fields inherited from class hlt.language.design.types.Type

      `ARRAY, BAG, BOOLEAN, BOXABLE, CHAR, CLASS, COLLECTION, CONSTANT, DEFINED, FUNCTION, INT, INT_RANGE, INT_SORT, LIST, NAMED_TUPLE, OBJECT_SORT, PARAMETER, REAL, REAL_RANGE, REAL_SORT, SET, STRING, TUPLE, VOID, VOID_SORT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SetType()` Constructs a polymorphic set type; i.e., one whose base type is a type parameter.
    `SetType(Type baseType)` Constructs a set type with the specified base type.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `byte` | `kind()` Returns the constant identifying set types; i.e., `Type.SET`.
    `CollectionType` | `newCollectionType(Type baseType)` Returns a new set type with the specified base type.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class hlt.language.design.types.CollectionType

      `baseType, baseTypeRef, checkOccurrence, copy, eqCode, flatten, getParameters, instantiate, isEqualTo, isEqualTo, isPolymorphic, numberOfTypeComponents, setTypeRefComponent, typeRefComponent, unify, unify`

    - ### Methods inherited from class hlt.language.design.types.Type

      `actualType, array, array, BOOLEAN, BOXED_BOOLEAN, BOXED_CHAR, BOXED_INT, BOXED_REAL, boxSort, CHAR, copy, curry, equals, findValue, getParameters, getValue, INT, is, isBag, isBoolean, isBoxedType, isChar, isCollection, isGlobalUnsafe, isInt, isList, isPrimitive, isReal, isSet, isString, isVoid, kindString, rank, REAL, resetNames, setBoxed, shadowType, sort, standardize, toFullString, toQuantifiedString, toQuantifiedString, typeComponent, unwrapper, value, wrapper`

    - ### Methods inherited from class java.lang.Object

      `getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### SetType

          public SetType()

      Constructs a polymorphic set type; i.e., one whose base type is a type parameter.

    - #### SetType

          public SetType(Type baseType)

      Constructs a set type with the specified base type.

  - ### Method Detail

    - #### newCollectionType

          public final CollectionType newCollectionType(Type baseType)

      Returns a new set type with the specified base type.
      Specified by:
        `newCollectionType` in class `CollectionType`

    - #### kind

          public final byte kind()

      Returns the constant identifying set types; i.e., `Type.SET`.
      Specified by:
        `kind` in class `Type`

    - #### toString

          public final java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`